<?php

/*
 * Discussion Board new topic class
*/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


class CT_DB_Pro_New_Topic {

	public function __construct() {
		//
	}

	/*
	 * Initialize the class and start calling our hooks and filters
	 * @since 1.0.0
	 */

	public function init() {
		add_filter( 'ctdb_topics_form', array( $this, 'filter_content' ) );
		add_filter( 'registered_taxonomy', array( $this, 'set_taxonomy_capability' ), 10, 3 );
	}
	
	/**
	 * Add wp_editor on frontend if selected
	 * Filters $form field
	 * @since 1.0.0
	 */	
	public function filter_content( $form ) {
		$options = get_option( 'ctdb_pro_settings' );
		if ( ! empty( $options['use_editor'] ) ) {
			$content = '';
			if( isset( $_POST['topic_content'] ) ) {
				$content = strip_shortcodes( stripslashes( $_POST['topic_content'] ) );
			}
			$media = false;
			if( isset( $options['enable_media_button'] ) ) {
				$media = true;
			}
			// Add media upload button if enabled
			ob_start();
			$args = array(
				'media_buttons'	=> $media,
				'tabindex'		=> 901,
			//	'teeny'			=> true,
				'quicktags' 	=> false,
				'tabindex'		=> 901
			);
			apply_filters( 'ctdb_editor_args', $args );
			wp_editor( wp_kses_post( $content ), 'topic_content', $args );
			$editor = ob_get_clean();
			
			$form['fields']['content'] = $editor;
		}
		return $form;

	}
	
	/**
	 * Allow users to set terms in taxonomies
	 * @since 1.5.3
	 */
	public function set_taxonomy_capability( $taxonomy, $object_type, $args ) {
		global $wp_taxonomies;
		if( ( 'topic-category' == $taxonomy || 'board' == $taxonomy ) && 'discussion-topics' == $object_type ) {
			$wp_taxonomies[$taxonomy]->cap->assign_terms = 'read';
		}
	}
	
}